package com.yihu.hos.logger.camel.route;

import com.yihu.hos.logger.configuration.LoggerConfiguration;
import org.apache.activemq.ActiveMQConnectionFactory;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.component.jms.JmsComponent;
import org.apache.camel.model.ModelCamelContext;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.jms.ConnectionFactory;

/**
 * Created by l4qiang on 2017-04-14.
 */
@Component
public class HosLogRouteBuilder extends RouteBuilder {
    static public final String DESTINATION_NAME = "business-log-hos";
    private static final String QUEUE_NAME = "business.log.queue";

    @Autowired
    private LoggerConfiguration loggerConfiguration;

    @Override
    public void configure() throws Exception {
        ModelCamelContext context = this.getContext();
        ConnectionFactory connectionFactory = new ActiveMQConnectionFactory(
                loggerConfiguration.getActiveMqUser(), loggerConfiguration.getActiveMqPassword(), loggerConfiguration.getBrokerURL());
        // Note we can explicit name the component
        context.addComponent(DESTINATION_NAME, JmsComponent.jmsComponentAutoAcknowledge(connectionFactory));
        from(DESTINATION_NAME + ":topic:" + QUEUE_NAME)
                .to("bean:businessLogService?method=log");
    }
}
